//HC-12 Receiver 8CH or 7CH + 8 SWCH
//Jean Louis Coural 15/03/2021

//  pinMode  digitalWrite
//  https://github.com/arduino/ArduinoCore-avr/blob/master/cores/arduino/wiring_digital.c
//  
//  UART
// mega2560 Serial_2  = UART2 Tx=D16  Rx=D17
// mega328p Serial_0 = UART  Tx=D1=pin30 Rx=D2=pin31
#define Serial_2

// UART0 display (only 2560 remove for 328p)
//#define _DISPLAY

#include<avr/io.h>
#include<avr/interrupt.h>
#include "RX433.h"
#include "dispatch.h"

// mode CHANELS or MULTISWITCH
#define MODE CHANELS
//#define MODE MULTISWITCH



void setup() 
	{
#if defined(_DISPLAY)	
	  Serial.begin(9600);  // remove if 328p
#endif
	  startReceiver(9600); 
	  prev = millis();	 	 
	  while(!NewFrame);
	  
	  pinMode(3, OUTPUT);  // CH1
	  pinMode(4, OUTPUT);
	  pinMode(5, OUTPUT);
	  pinMode(6, OUTPUT);
	  pinMode(7, OUTPUT);
	  pinMode(8, OUTPUT);
	  pinMode(9, OUTPUT);
	  pinMode(10, OUTPUT); // CH8
	  
	  timer_init();
  
	}
  
  
void loop() 
	{  
		 if(NewFrame)    
		  {          
				uint8_t tmp_arr[DATASIZE];
				//while(TCNT1 > 65450 );    // wait if T1 about to overflow
				for (uint8_t i = 0; i < DATASIZE; i++) tmp_arr[i] = inUart_arr[i];
				NewFrame = false; 				
				if( CRC8(tmp_arr,DATASIZE-1) == tmp_arr[DATASIZE - 1] )
				{
				  for (uint8_t j = 0; j < DATASIZE - 1; j++)  
				    if(tmp_arr[j] > 0 && MODE == ChFrame) receiv_arr[j] = tmp_arr[j]; // 0.865 ms at least or bad pulse

#if defined(_DISPLAY)					
					  String ms = " ms";
					  String ch = "CH ";
					  if(!ChFrame) ch = "SW ";
					  unsigned long now = millis();
					  unsigned long my_delay = now - prev;
					  prev = now;				  
					  if(MODE == ChFrame) Serial.println(ch + my_delay + ms);                     
					  for (uint8_t j = 0; j < DATASIZE - 1; j++)     
						{
							Serial.print(receiv_arr[j]);
							Serial.print("  ");
						}					
					 Serial.println("  ");	
           
#endif		
	 
				}      
		  }
    
	}
