// JL Coural 09/02/2021
// version haut debit
// buffer circulaire
// https://forum.arduino.cc/index.php?topic=309651.0
//http://arduinomega.blogspot.com/2011/05/setting-interrupts-manually-real-int0.html

//#include "Arduino.h"
//#include "UartAndPinConfig.h"
#include <avr/interrupt.h> 
#include <avr/io.h>
#include "ppm_config.h"

// pin 2 RC filter
// 1K serie 100 nF parlell
// 5K serie better no cap oscillo test to do

void ppm_init(){
  //pinMode(53, OUTPUT); //attached to LED 
  pinMode(2, INPUT);     //pin 2 tied to INT4
  EIMSK = 0x00;
  EICRB = 0x02;          //INT4, triggered on falling edge (0x03 rising)
  EIMSK = 0x10;          //Enable only INT4
  
	// Timer3 16bits for pulse mesurement CPU Freq 16Mhz
	// for interval of 1ms ==> 0,001/(1/16000000) = 16.000 ticks
	// Prescaler 8 ==> resolution changes from 0,0000000625 to 0,0000005 = 0.5 uS
	// Need interval of 3Ms ==> 0,003/((1/16000000)*8) = 6000 ticks 0x1770
	// Set prescaler to 1/8 ; (1 << CS31)  (p. 162)
	
TCCR3A = 0;  
TCCR3B = 0x02;
TCNT3 = 0;	

  for (uint8_t i=0; i<9; i++)
  {
    msw_buf[i] = 0;
    ppm_buf[i] = 0;
  }
}


void PUSH(uint16_t data, uint16_t *buf, uint8_t len)
{
  
  for (uint8_t i=0; i<len; i++)
      buf[i] = buf[i+1];
  
  buf[len] = data;  
 
}


// MSW on CH8
ISR(INT4_vect) { 
  
  if(TCNT3 >= TSYNC) // PPM SYNC found; last puls = CH8 
  {
	  PUSH(puls, msw_buf, 8);   
	  if(puls <= TSYNCM && !MSWdataReady && !CHdataReady) 
	    { 
	      MSWdataReady = true;
		  for(uint8_t i = 0; i <9; i++) tmp_buf[i] = msw_buf[i]; 
	    }
	  
    puls = TCNT3;
    TCNT3 = 0 ;  
    PUSH(puls, ppm_buf, 8);

    if(!CHdataReady && !MSWdataReady) 
      {
        CHdataReady = true;
        for(uint8_t i = 0; i <9; i++) tmp_buf[i] = ppm_buf[i]; 
      }
          
  }  
  else
  {
		puls = TCNT3;
		TCNT3 = 0 ;  
		PUSH(puls, ppm_buf, 8);   
  } 
      
}

								
