// header file for  PPM2


//-----------------------------------------------------------------------------
// MACROS
//-----------------------------------------------------------------------------

#define US_TO_T3_TICK(us)    (uint16_t)(us * 2)  // Macro pour convertir des micro-secondes en tick du Timer3

#define TSYNC  	US_TO_T3_TICK(3000)  	// set here PPM sync time 3 ms at least 
#define TSYNCM 	US_TO_T3_TICK(1000)  	// set here multiswitch sync time < 1 ms 
#define PULSMIN US_TO_T3_TICK(1160)	  	// 1160 uS	
#define PULSMID  US_TO_T3_TICK(1500)    // 1500 uS  1500-1160 = 340 = 170*2
#define PULSMAX  US_TO_T3_TICK(1840)    // 1840 uS
#define BADPULS	 US_TO_T3_TICK(600)		// 600 uS
#define MAX  	 1360				//  1360*0.5 = 670 uS
#define MID  	 680				//  680*0.5  = 340 uS
#define DZ       30				// servo dead zone (30)
#define DCstall 0xF0
#define SW_ON 	US_TO_T3_TICK(1300) // switch on/off active if puls > 1.3 ms
#define NEUTRAL 0x00
#define RIGHT   0x01
#define LEFT    0x02
#define MOT		0x00
#define SERV   	0x01
#define ACTIV   0x02
#define SYNCHRO 0x00	// synchronisation = chanel 0
#define STDCH   0x01    // standard chanel
#define SWCH	0x02    // multiswitch chanel
#define CH   1       // debug dispaly
#define SW   2       // debug dispaly
#define BCH   3       // debug dispaly
#define BSW   4       // debug dispaly

// ISR flags
volatile boolean sync = false;			// synchronisation time found or not on ppm
volatile boolean syncm = false;			// synchronisation time found or not on multiswitch chanel 8
volatile boolean CHdataReady = false;	// set when ppm frame full
volatile boolean MSWdataReady = false;	// set when multiswitch frame full


//uint8_t chanel;			// chanel #
//uint8_t multi;			// multiswitch chanel #
volatile  uint16_t ppm_buf[9];	// ppm buffer
volatile  uint16_t msw_buf[9];	// multiswitch buffer
volatile uint16_t  tmp_buf[9];  // for transfer
volatile uint16_t  puls;	      // RC puls length 65535 max

uint8_t  tx_buf[8];            // transmission buffer
uint16_t tmp;       	        // for shifted pulse

//volatile boolean toto = false;  // debug
		 
//-----------------------------------------------------------------------------
// Functions PROTOTYPES
//-----------------------------------------------------------------------------		

void evaluate_chanel(void);
void evaluate_mswitch(void);
void update_dc(uint8_t target);
void evaluate_swchanel(void);
uint8_t BADPULSE(uint8_t chanelType);
void update_data(uint8_t target);
